package it.eng.configurazione.test;

import java.util.Iterator;
import java.util.Set;

import org.hibernate.Session;

import it.eng.configurazione.bean.ConnetionParameter;
import it.eng.configurazione.bean.DataSource;
import it.eng.configurazione.bean.ExtractionProcess;
import it.eng.configurazione.bean.Field;
import it.eng.configurazione.bean.Interface;
import it.eng.configurazione.bean.Operation;
import it.eng.configurazione.bean.OperationParameter;
import it.eng.configurazione.bean.SourceType;
import it.eng.configurazione.service.ConfigurationDAO;
import it.eng.configurazione.service.HibernateUtils;
import junit.framework.TestCase;

public class OperationTest extends TestCase {

	DataSource dataSourceTest=null;
	SourceType tipo=null;
	Interface interfacciaTest=null;
	Operation operazione=null;
	ExtractionProcess processo=null;
	Session sessione= HibernateUtils.getSession();
	public OperationTest(String name) {
		super(name);
		
	}
	/*
	protected void setUp() throws Exception {
		
		interfacciaTest=new Interface();
		interfacciaTest.setClassforname("it.eng.test.managerImpl.class");
		interfacciaTest.setName("Interfaccia_Requisiti");
		interfacciaTest.setDescription("Questa interfaccia definisce tutti i campi dei requisiti");
		//interfacciaTest.setXmlSchema("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" elementFormDefault=\"qualified\" attributeFormDefault=\"unqualified\" targetNamespace=\"http://egov.diviana.it/Fiscali\" xmlns=\"http://egov.diviana.it/Fiscali\" xmlns:OggettiCondivisi=\"http://egov.diviana.it/OggettiCondivisi\" xmlns:DocumentiUfficiali=\"http://egov.diviana.it/DocumentiUfficiali\"><xs:annotation><xs:documentation>Copyright Diviana sas 2002-2004 - Prodotto da Diviana sas  per conto di Progetto People</xs:documentation><xs:documentation>Tutti i diritti riservati</xs:documentation></xs:annotation><xs:import namespace=\"http://egov.diviana.it/DocumentiUfficiali\" schemaLocation=\"DocumentiUfficiali.xsd\"/><xs:import namespace=\"http://egov.diviana.it/OggettiCondivisi\" schemaLocation=\"OggettiCondivisi.xsd\"/><xs:complexType name=\"RichiestadiProvvedimentiICIEmessiVersoilContribuenteconDettagliodiSanzionieInteressi\"><xs:complexContent><xs:extension base=\"OggettiCondivisi:RichiestadiServizioOnLineallaPA\"><xs:sequence><xs:element name=\"CartelladiProvvedimentiICI\" type=\"CartelladiProvvedimentiICI\"/></xs:sequence></xs:extension></xs:complexContent></xs:complexType><xs:complexType name=\"CartelladiProvvedimentiICI\"><xs:complexContent><xs:extension base=\"OggettiCondivisi:Risposta\"><xs:sequence><xs:element name=\"CartelladiProvvedimentiICI\" type=\"DocumentiUfficiali:CartelladiProvvedimentiICI\"/><xs:element name=\"ProvvedimentoICI\" type=\"ProvvedimentoICI\" minOccurs=\"0\" maxOccurs=\"unbounded\"/></xs:sequence></xs:extension></xs:complexContent></xs:complexType><xs:complexType name=\"Provvedimento\" abstract=\"true\"><xs:sequence><xs:element name=\"AnnodiApplicazione\" type=\"OggettiCondivisi:Anno\"/><xs:element name=\"CodiceFiscale\" type=\"OggettiCondivisi:CodiceFiscale\"/><xs:element name=\"DatadelProvvedimento\" type=\"OggettiCondivisi:Data\"/><xs:element name=\"Stato\" type=\"Stato\"/><xs:element name=\"DifferenzatraDovutoeVersato\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"Sanzioni\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"Interessi\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"Spese\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/><xs:element name=\"ImportoTotale\" type=\"OggettiCondivisi:Importo\"/><xs:element name=\"ImportoVersato\" type=\"OggettiCondivisi:Importo\" minOccurs=\"0\"/></xs:sequence></xs:complexType><xs:simpleType name=\"Stato\"><xs:restriction base=\"xs:string\"><xs:enumeration value=\"Emesso\"/><xs:enumeration value=\"Notificato\"/><xs:enumeration value=\"Sospeso\"/><xs:enumeration value=\"Pagato\"/><xs:enumeration value=\"Annullato\"/><xs:enumeration value=\"A Ruolo Coattivo\"/></xs:restriction></xs:simpleType><xs:complexType name=\"ProvvedimentoICI\"><xs:complexContent><xs:extension base=\"Provvedimento\"><xs:sequence><xs:element name=\"TipodiProvvedimentoICI\" type=\"TipodiProvvedimentoICI\"/><xs:element name=\"IdentificatorediProvvedimentoICI\" type=\"IdentificatorediProvvedimentoICI\"/></xs:sequence></xs:extension></xs:complexContent></xs:complexType><xs:simpleType name=\"TipodiProvvedimentoICI\"><xs:restriction base=\"xs:string\"><xs:enumeration value=\"Accertamento\"/><xs:enumeration value=\"Liquidazione\"/><xs:enumeration value=\"Rimborso\"/><xs:enumeration value=\"Rateizzazione del Pagamento\"/><xs:enumeration value=\"Annullamento\"/><xs:enumeration value=\"Irrogazione di Sanzione Generica\"/></xs:restriction></xs:simpleType><xs:complexType name=\"IdentificatorediProvvedimentoICI\"><xs:complexContent><xs:extension base=\"OggettiCondivisi:Identificatore\"/></xs:complexContent></xs:complexType></xs:schema>");
		
		processo=new ExtractionProcess();
		processo.setInterfaceInfo(interfacciaTest);
		processo.setName("PROCESSO_1");
		processo.setDescription("Descrizione processo1");
		processo.setInterfaceInfo(interfacciaTest);
		
		ConnetionParameter conP1=new ConnetionParameter();
		conP1.setName("USER");
		conP1.setValue("pippo");
		ConnetionParameter conP2=new ConnetionParameter();
		conP2.setName("PASSWORD");
		conP2.setValue("pippo");		
		
		tipo=new SourceType();
		tipo.setName("JIRA");
		tipo.setDescription("TIPOLOGIA DI SORGENTE JIRA");
		tipo.setClassforname("it.eng.EstrattoreJira.class");
		
		dataSourceTest=new DataSource();
		dataSourceTest.setDescription("Connessione al jira di test");
		dataSourceTest.setName("JIRA_TEST");
		dataSourceTest.setSource(tipo);
		dataSourceTest.addParameter(conP1);
		dataSourceTest.addParameter(conP2);

		operazione=new Operation();
		operazione.addProcess(processo);
		operazione.setDataSource(dataSourceTest);
		operazione.setName("LetturaJira");

		// aggiungo l'operazione al processo
		//processo.addOperation(operazione);
		
		Field campo1=new Field();
		campo1.setName("STATO");
		campo1.setInterfacePosition("1");
		campo1.setMappingScript("Script groovy");
		campo1.setType("Stringa");
		Field campo2=new Field();
		campo2.setName("DESCRIZIONE");
		campo2.setInterfacePosition("2");
		campo2.setMappingScript("Script groovy");
		campo2.setType("Stringa");
		
		OperationParameter operPar1=new OperationParameter();
		operPar1.setName("QUERY");
		operPar1.setValue("SELECT * FROM TABELLA;");
		OperationParameter operPar2=new OperationParameter();
		operPar2.setName("PROGETTO");
		operPar2.setValue("PROGETTO NUOVO");
		
		operazione.addField(campo1);
		operazione.addField(campo2);
		operazione.addParameter(operPar1);
		operazione.addParameter(operPar2);

		sessione.beginTransaction();
		sessione.save(interfacciaTest);
		sessione.save(processo);
		sessione.save(tipo);
		sessione.save(dataSourceTest);
		sessione.save(operazione);
		sessione.getTransaction().commit();
	}

	protected void tearDown() throws Exception {

		sessione.beginTransaction();
		sessione.delete(operazione);
		sessione.delete(dataSourceTest);
		sessione.delete(tipo);
		sessione.delete(processo);
		sessione.delete(interfacciaTest);
		sessione.getTransaction().commit();		
	}


	public void testLetturaOperation() {
		ConfigurationDAO dao=new ConfigurationDAO();
		Operation tmp=dao.readOperation("LetturaJira");
		assertEquals(tmp.getName(), operazione.getName());
		assertEquals(tmp.getId(), operazione.getId());

	}
*/	
	public void testLetturaExtractionProcess() {
		ConfigurationDAO dao=new ConfigurationDAO();
		ExtractionProcess tmp=dao.readExtractionProcess("PROCESSO_JIRA");
		assertEquals(tmp.getName(), processo.getName());
		assertEquals(tmp.getId(), processo.getId());

	}	
	
	private boolean contain(ConnetionParameter c, Set<ConnetionParameter> insieme){
		Iterator<ConnetionParameter> iter=insieme.iterator();
		while (iter.hasNext()){
			ConnetionParameter tmp=iter.next();
			if (c.getName().equals(tmp.getName()) && c.getValue().equals(tmp.getValue()))return true;
		}
		return false;
	}

}
